AppTitle("DirectoReview - Info")

Type review
	Field id%
	Field path$
	Field name$
	Field datatype$
	Field limit%
	Field filecount%
End Type

Type invalid
	Field path$
End Type

Global timer%=CreateTimer(0.02)

Repeat
	ReviewDir()
	WriteReview()
	ClearTypes()
	WaitTimer(timer%)
Forever

;FUNCTIONS---------------------------------------------------------------------------------------

Function ReviewDir()
	Local l$,pcount%,nextstart%,nextpath$,nextname$,nextdatatype$,nextlimit$,nextid%,n%,c%,dir%
	If FileType("DirectoReview.txt")=True Then
		Local filein%=ReadFile("DirectoReview.txt")
		While Eof(filein%)=False
			l$=ReadLine(filein%)
			l$=Replace(l$,"  "," ")
			l$=Replace(l$,", ",",")
			If Instr(l$,"//")=False And Left(l$,10)="ReviewDir(" And Right(l$,2)=");" And l$<>"" Then
				For n%=1 To Len(l$)
					If Mid(l$,n%,1)="," Then c%=c%+1
				Next
				If c%=3 Then
					pcount%=Instr(l$,",",1)-11
					nextpath$=Mid(l$,11,pcount%)
					nextstart%=11+Len(nextpath$)+1
					
					pcount%=Instr(l$,",",nextstart%)-nextstart%
					nextname$=Mid(l$,nextstart%,pcount%)
					nextstart%=nextstart+Len(nextname$)+1
					
					pcount%=Instr(l$,",",nextstart%)-nextstart%
					nextdatatype$=Mid(l$,nextstart%,pcount%)
					nextstart%=nextstart+Len(nextdatatype$)+1
					
					pcount%=Instr(l$,")",nextstart%)-nextstart%
					nextlimit$=Mid(l$,nextstart%,pcount%)
					
					If nextpath$<>"" And nextname$<>"" And nextdatatype$<>"" And nextlimit$<>"" And FileType(nextpath$)=2 Then
						nextid%=nextid%+1
						add.review=New review
						add\id%=nextid%
						add\path$=nextpath$
						add\name$=nextname$
						add\datatype$=nextdatatype$
						add\limit%=ConvertString(nextlimit$)
						dir%=ReadDir(nextpath$)
						NextFile(dir%)
						NextFile(dir%)
						nf$=NextFile(dir%)
						While nf$<>""
							If Instr(nextdatatype$,Right(nf$,3))<>False Then add\filecount%=add\filecount%+1
							nf$=NextFile(dir%)
						Wend
						CloseDir dir%
					Else
						more.invalid=New invalid
						more\path$=nextpath$
					End If
				End If
				c%=0
			End If
		Wend
		CloseFile filein%
	Else
		If Confirm("     Konfigurationsdatei nicht gefunden."+Chr$(10)+Chr$(10)+"     Neue Konfigurationsdatei erstellen?",1)=True Then
			Local fileout%=WriteFile("DirectoReview.txt")
			WriteLine fileout%,"//DirectoReview R1.00, 27.08.16 by D.Schaer"
			WriteLine fileout%,"//Syntax: ReviewDir(Pfad[$],Bezeichnung[$],Dateityp[$],Limite[%]);"
			WriteLine fileout%,""
			CloseFile fileout%
			ExecFile("DirectoReview.txt")
		End If
		End
	End If	
End Function

Function WriteReview()
	Local ul%,ol%,t2h%,t1h%,iv%
	Local fileout%=WriteFile("DirectoReview.html")
	WriteLine fileout%,"<!DOCTYPE HTML PUBLIC "+Chr$(34)+"-//W3C//DTD HTML 4.01//EN"+Chr$(34)+">"
	WriteLine fileout%,"<html lang="+Chr$(34)+"de"+Chr$(34)+">"
	WriteLine fileout%,""
	
	WriteLine fileout%,Chr$(9)+"<head>"
	WriteLine fileout%,String(Chr$(9),2)+"<link href="+Chr$(34)+"DirectoReview.css"+Chr$(34)+" rel="+Chr$(34)+"stylesheet"+Chr$(34)+">"
	WriteLine fileout%,String(Chr$(9),2)+"<link rel="+Chr$(34)+"shortcut icon"+Chr$(34)+" Type="+Chr$(34)+"image/x-icon"+Chr$(34)+" href="+Chr$(34)+"./DirectoReview.ico"+Chr$(34)+"/>"
	WriteLine fileout%,String(Chr$(9),2)+"<meta http-equiv="+Chr$(34)+"content-type"+Chr$(34)+" content="+Chr$(34)+"text/html; charset=utf-8"+Chr$(34)+">"
	WriteLine fileout%,String(Chr$(9),2)+"<meta http-equiv="+Chr$(34)+"refresh"+Chr$(34)+" content="+Chr$(34)+"30"+Chr$(34)+">"
	WriteLine fileout%,String(Chr$(9),2)+"<title>Lizenzbestand</title>"
	WriteLine fileout%,Chr$(9)+"</head>"
	WriteLine fileout%,""
	
	WriteLine fileout%,Chr$(9)+"<body>"
	WriteLine fileout%,String(Chr$(9),2)+"<img src="+Chr$(34)+"./Logo.jpg"+Chr$(34)+" width="+Chr$(34)+"200"+Chr$(34)+" style="+Chr$(34)+"margin:10px;"+Chr$(34)+"</img>"
	WriteLine fileout%,String(Chr$(9),2)+"<div id="+Chr$(34)+"panel"+Chr$(34)+">"
	WriteLine fileout%,String(Chr$(9),2)+"<h1>Lizenzbestand:</h1>"
	
	For display.review=Each review
		If display\filecount%<display\limit% Then ul%=ul%+1
		If display\filecount%>=display\limit% Then ol%=ol%+1
	Next
	For show.invalid=Each invalid
		iv%=iv%+1
	Next
	
	If ul%>0 Then
		WriteLine fileout%,String(Chr$(9),2)+"<p class="+Chr$(34)+"status"+Chr$(34)+"><span>Status: </span><span style="+Chr$(34)+"Color:red;font-weight:bold;"+Chr$(34)+"> "+ul%+" Limite(n) erreicht</span></p>"
	Else	
		If iv%=0 Then
			If ol%>0 Then WriteLine fileout%,String(Chr$(9),2)+"<p class="+Chr$(34)+"status"+Chr$(34)+"><span>Status: </span><span style="+Chr$(34)+"Color:green;font-weight:bold;"+Chr$(34)+"> OK </span></p>"		
			If ol%=0 Then WriteLine fileout%,String(Chr$(9),2)+"<p class="+Chr$(34)+"status"+Chr$(34)+"><span>Status: </span><span style="+Chr$(34)+"Color:gray;font-weight:bold;"+Chr$(34)+"> Unvollstaendige Konfiguration </span></p>"
		End If	
	End If	
		
	For display.review=Each review
		If ul%>0 Then
			If t2h%=False Then
				WriteLine fileout%,String(Chr$(9),2)+"<table class="+Chr$(34)+"t2"+Chr$(34)+" title="+Chr$(34)+"Bestand unter Limite"+Chr$(34)+" style="+Chr$(34)+"width:100%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),3)+"<colgroup>"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:5%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:20%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:5%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:40%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),3)+"</colgroup>"
				WriteLine fileout%,String(Chr$(9),3)+"<tr>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">ID</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">Bezeichnung</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">Limite</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"left"+Chr$(34)+">Bestand</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"left"+Chr$(34)+">Pfad</th>"
				WriteLine fileout%,String(Chr$(9),3)+"</tr>"
				t2h%=True
			End If
			If display\filecount%<display\limit% Then
				WriteLine fileout%,String(Chr$(9),3)+"<tr>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\id%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\name$+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\limit%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"left"+Chr$(34)+">"+display\filecount%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"left"+Chr$(34)+">"+display\path$+"</th>"
				WriteLine fileout%,String(Chr$(9),3)+"</tr>"
			End If
		End If
	Next
	If ul%>0 Then WriteLine fileout%,String(Chr$(9),2)+"</table>"
	
	If ol%>0 Then
		For display.review=Each review
			If t1h%=False Then
				WriteLine fileout%,String(Chr$(9),2)+"<table class="+Chr$(34)+"t1"+Chr$(34)+" title="+Chr$(34)+"Bestand OK"+Chr$(34)+" style="+Chr$(34)+"width:100%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),3)+"<colgroup>"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:5%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:20%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:5%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),4)+"<col style="+Chr$(34)+"width:40%;"+Chr$(34)+">"
				WriteLine fileout%,String(Chr$(9),3)+"</colgroup>"
				WriteLine fileout%,String(Chr$(9),3)+"<tr>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">ID</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">Bezeichnung</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"center"+Chr$(34)+">Limite</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"left"+Chr$(34)+">Bestand</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<th align="+Chr$(34)+"left"+Chr$(34)+">Pfad</th>"
				WriteLine fileout%,String(Chr$(9),3)+"</tr>"
				t1h%=True
			End If
			If display\filecount%>=display\limit% Then
				WriteLine fileout%,String(Chr$(9),3)+"<tr>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\id%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\name$+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"center"+Chr$(34)+">"+display\limit%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"left"+Chr$(34)+">"+display\filecount%+"</th>"
				WriteLine fileout%,String(Chr$(9),4)+"<td align="+Chr$(34)+"left"+Chr$(34)+">"+display\path$+"</th>"
				WriteLine fileout%,String(Chr$(9),3)+"</tr>"
			End If
		Next
		If t1h%=True Then WriteLine fileout%,String(Chr$(9),2)+"</table>"
	End If
	
	WriteLine fileout%,String(Chr$(9),2)+"<span>Aktualisiert am "+CurrentDate()+"; "+Left(CurrentTime(),5)+" Uhr durch "+GetEnv("USERNAME")+"</span><br>"
	
	If iv%>0 Then
		WriteLine fileout%,String(Chr$(9),2)+"<br>"
		WriteLine fileout%,String(Chr$(9),2)+"<span style="+Chr$(34)+"font-weight:bold;"+Chr$(34)+">Ungueltige und somit nicht untersuchte Pfade:</span><br>"
		For show.invalid=Each invalid
			WriteLine fileout%,String(Chr$(9),2)+"<span>"+show\path$+"</span><br>"
		Next
	End If
	
	WriteLine fileout%,String(Chr$(9),2)+"</div>"
	WriteLine fileout%,Chr$(9)+"</body>"
	
	WriteLine fileout%,"</html>"
	
	CloseFile fileout%
End Function

Function ClearTypes()
	For del1.review=Each review
		Delete del1.review
	Next
	For del2.invalid=Each invalid
		Delete del2.invalid
	Next	
End Function

Function ConvertString#(word$)
	
	Local ppos%
	Local pol%
	Local i%
	Local newword$
	Local part%
	Local value%
	Local result#
	
	If Left(word$,1)="-" Then
		pol%=-1
		word$=Replace(word$,"-","")
	Else
		pol%=1
	End If
	
	For i%=1 To Len(word$)
		Select Mid(word$,i%,1)
			Case "0"
				newword$=newword$+"0"		
			Case "1"
				newword$=newword$+"1"
			Case "2"
				newword$=newword$+"2"
			Case "3"
				newword$=newword$+"3"
			Case "4"
				newword$=newword$+"4"
			Case "5"
				newword$=newword$+"5"
			Case "6"
				newword$=newword$+"6"
			Case "7"
				newword$=newword$+"7"
			Case "8"
				newword$=newword$+"8"
			Case "9"
				newword$=newword$+"9"
			Case ",","."
				If part%=0 Then
					ppos%=i%-1
					part%=1
				End If
		End Select
	Next
	
	If ppos%=0 Then ppos%=Len(newword$)
	
	For i%=1 To Len(newword$)
		Select Mid(newword$,i%,1)
			Case "0"
				value%=value%+Int(0*10^(Len(newword$)-i%))		
			Case "1"
				value%=value%+Int(1*10^(Len(newword$)-i%))
			Case "2"
				value%=value%+Int(2*10^(Len(newword$)-i%))
			Case "3"
				value%=value%+Int(3*10^(Len(newword$)-i%))
			Case "4"
				value%=value%+Int(4*10^(Len(newword$)-i%))
			Case "5"
				value%=value%+Int(5*10^(Len(newword$)-i%))
			Case "6"
				value%=value%+Int(6*10^(Len(newword$)-i%))
			Case "7"
				value%=value%+Int(7*10^(Len(newword$)-i%))
			Case "8"
				value%=value%+Int(8*10^(Len(newword$)-i%))
			Case "9"
				value%=value%+Int(9*10^(Len(newword$)-i%))
		End Select
	Next	
	
	result#=Float(value%/(10^(Len(newword$)-ppos%))*pol%)
	Return result#
End Function


;~IDEal Editor Parameters:
;~C#BlitzPlus